'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ManualLoad = require('../ManualLoad');

var _ManualLoad2 = _interopRequireDefault(_ManualLoad);

var _LazyLoad = require('../LazyLoad');

var _LazyLoad2 = _interopRequireDefault(_LazyLoad);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var nativeConnection = (typeof window === 'undefined' ? 'undefined' : _typeof(window)) !== undefined && !!window.navigator.connection;

var AdaptiveLoad = function (_Component) {
  _inherits(AdaptiveLoad, _Component);

  function AdaptiveLoad(props) {
    _classCallCheck(this, AdaptiveLoad);

    var _this = _possibleConstructorReturn(this, (AdaptiveLoad.__proto__ || Object.getPrototypeOf(AdaptiveLoad)).call(this, props));

    _this.state = {
      loadState: _constants.loadStates.initial,
      connection: nativeConnection ? navigator.connection.effectiveType // 'slow-2g', '2g', '3g', or '4g'
      : null,
      canceled: false,
      overThreshold: false
    };
    return _this;
  }

  _createClass(AdaptiveLoad, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (!this.state.controledConnection) {
        if (nativeConnection) {
          this.updateConnection = function () {
            if (!navigator.onLine) return;
            if (_this2.state.loadState === _constants.loadStates.initial) {
              _this2.setState({ connection: navigator.connection.effectiveType });
            }
          };
          navigator.connection.addEventListener('onchange', this.updateConnection);
        } else if (this.props.threshold) {
          this.overThresholdListener = function (e) {
            if (_this2.state.loadState !== _constants.loadStates.initial) return;
            var overThreshold = e.detail.overThreshold;

            if (!_this2.state.overThreshold && overThreshold) {
              _this2.setState({ overThreshold: overThreshold });
            }
          };
          window.document.addEventListener('overThreshold', this.overThresholdListener);
          // this.connectionListener = e => {
          //   if (this.state.loadState !== loadStates.initial) return;
          //   const { size, time } = e.detail;
          //   const speed = 8 * size / time; //Kbps
          //   if (speed < 400 && this.state.connection > "3g") {
          //     this.setState({ connection: "3g" });
          //   }
          // };
          // window.document.addEventListener("connection", this.connectionListener);
        }
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (!this.state.controledOnLine) {
        if (nativeConnection) {
          navigator.connection.removeEventListener('onchange', this.updateConnection);
        } else if (this.props.threshold) {
          window.document.removeEventListener('overThreshold', this.overThresholdListener);
          // window.document.removeEventListener(
          //   "connection",
          //   this.connectionListener
          // );
        }
      }
    }
  }, {
    key: 'stateToComponent',
    value: function stateToComponent(_ref) {
      var connection = _ref.connection,
          canceled = _ref.canceled,
          overThreshold = _ref.overThreshold;

      var autoLoad = nativeConnection ? this.props.connectionToLoad(connection, this.props) : true;
      if (canceled || overThreshold || !autoLoad) {
        return _ManualLoad2.default;
      } else {
        return _LazyLoad2.default;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      return _react2.default.createElement(this.stateToComponent(this.state), _extends({}, this.props, {
        onLoadStateChange: function onLoadStateChange(loadState) {
          return _this3.setState({
            loadState: loadState,
            canceled: loadState === _constants.loadStates.initial
          });
        }
      }));
    }
  }]);

  return AdaptiveLoad;
}(_react.Component);

AdaptiveLoad.propTypes = {
  threshold: _propTypes2.default.number,
  connectionToLoad: _propTypes2.default.func
};
AdaptiveLoad.defaultProps = {
  /**
   * @param {string} connection - effective connection type e.g. 'slow-2g', '2g', '3g', or '4g'
   * @returns {boolean} - is connection good enough to auto load the image
   */
  connectionToLoad: function connectionToLoad(connection, _ref2) {
    var size = _ref2.size,
        threshold = _ref2.threshold;

    switch (connection) {
      case 'slow-2g':
      case '2g':
        return false;
      case '3g':
        if (!size || !threshold) {
          return false; // don't load
        } else {
          // assume slow 3g e.g. 400Kbps
          // threshold is in ms
          return size * 8 / 400 < threshold;
        }
      case '4g':
        return true;
      default:
        return true;
    }
  }
};
exports.default = AdaptiveLoad;


AdaptiveLoad.props = _ManualLoad2.default.props;