'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Media = require('../Media');

var _Media2 = _interopRequireDefault(_Media);

var _constants = require('../constants');

var _defaultIcons = require('../defaultIcons');

var _defaultIcons2 = _interopRequireDefault(_defaultIcons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var initial = _constants.loadStates.initial,
    loading = _constants.loadStates.loading,
    loaded = _constants.loadStates.loaded,
    error = _constants.loadStates.error;

var ManualLoad = function (_Component) {
  _inherits(ManualLoad, _Component);

  function ManualLoad(props) {
    _classCallCheck(this, ManualLoad);

    var _this = _possibleConstructorReturn(this, (ManualLoad.__proto__ || Object.getPrototypeOf(ManualLoad)).call(this, props));

    var controledOnLine = props.onLine !== undefined;
    var controledLoad = props.load !== undefined;
    _this.state = {
      onLine: controledOnLine ? props.onLine : true,
      controledLoad: controledLoad,
      controledOnLine: controledOnLine,
      loadState: initial,
      overThreshold: false
    };
    return _this;
  }

  _createClass(ManualLoad, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.load) this.load();
      if (!this.state.controledOnLine) {
        this.updateOnlineStatus = function () {
          return _this2.setState({ onLine: navigator.onLine });
        };
        this.updateOnlineStatus();
        window.addEventListener('online', this.updateOnlineStatus);
        window.addEventListener('offline', this.updateOnlineStatus);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.clear();
      if (!this.state.controledOnLine) {
        window.removeEventListener('online', this.updateOnlineStatus);
        window.removeEventListener('offline', this.updateOnlineStatus);
      }
    }

    // TODO: fix this
    // eslint-disable-next-line camelcase

  }, {
    key: 'UNSAFE_componentWillReceiveProps',
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.state.controledLoad && nextProps.load === undefined) {
        throw new Error('You should pass load value to controlled component');
      }
      if (this.state.controledOnLine) {
        if (nextProps.onLine === undefined) {
          throw new Error('You should pass onLine value to controlled component');
        } else {
          this.setState({ onLine: nextProps.onLine });
        }
      }
      if (nextProps.load === true) this.load();
      if (nextProps.load === false) this.cancel();
      if (nextProps.src !== this.props.src) this.cancel();
    }
  }, {
    key: 'onClick',
    value: function onClick() {
      var _state = this.state,
          loadState = _state.loadState,
          onLine = _state.onLine,
          overThreshold = _state.overThreshold;

      if (!onLine) return;
      switch (loadState) {
        case loading:
          if (overThreshold) this.cancel();
          return;
        case loaded:
          // nothing
          return;
        case initial:
        case error:
          this.load();
          return;
        default:
          throw new Error('Wrong state: ' + loadState);
      }
    }
  }, {
    key: 'clear',
    value: function clear() {
      var image = this.image;
      if (this.image) {
        clearInterval(this.refreshIntervalId);
        this.refreshIntervalId = undefined;
        // eslint-disable-next-line no-multi-assign
        image.onabort = image.onerror = image.onload = undefined;
        this.image.src = '';
        // eslint-disable-next-line no-multi-assign
        this.image = image = undefined;
      }
    }
  }, {
    key: 'cancel',
    value: function cancel() {
      var loadState = this.state.loadState;

      if (loading !== loadState) return;
      this.clear();
      this.loadStateChange(initial);
    }
  }, {
    key: 'loadStateChange',
    value: function loadStateChange(loadState) {
      this.setState({ loadState: loadState, overThreshold: false });
      var onLoadStateChange = this.props.onLoadStateChange;
      if (onLoadStateChange) onLoadStateChange(loadState);
    }
  }, {
    key: 'startTimer',
    value: function startTimer() {
      var _this3 = this;

      var threshold = this.props.threshold;

      if (!threshold) return undefined;
      var startTime = new Date().getTime();
      return setInterval(function () {
        var time = new Date().getTime() - startTime;
        // window.document.dispatchEvent(
        //   new CustomEvent("connection", {
        //     detail: { time, size, overThreshold: threshold && time > threshold }
        //   })
        // );
        if (time < threshold) return;
        _this3.setState({ overThreshold: true });
        window.document.dispatchEvent(new CustomEvent('overThreshold', { detail: { overThreshold: true } }));
      }, this.props.interval);
    }
  }, {
    key: 'load',
    value: function load() {
      var _this4 = this;

      var loadState = this.state.loadState;

      if (loaded === loadState || loading === loadState) return;
      this.loadStateChange(loading);
      this.refreshIntervalId = this.startTimer();
      var image = new Image();
      image.onload = function () {
        _this4.clear();
        _this4.loadStateChange(loaded);
      };
      // eslint-disable-next-line no-multi-assign
      image.onabort = image.onerror = function () {
        _this4.clear();
        _this4.loadStateChange(error);
      };
      image.src = this.props.src;
      this.image = image;
    }
  }, {
    key: 'stateToIcon',
    value: function stateToIcon(_ref) {
      var loadState = _ref.loadState,
          onLine = _ref.onLine,
          overThreshold = _ref.overThreshold;

      switch (loadState) {
        case loaded:
          return _constants.icons.loaded;
        case loading:
          return overThreshold ? _constants.icons.loading : _constants.icons.noicon;
        case initial:
          return onLine ? _constants.icons.load : _constants.icons.offline;
        case error:
          return onLine ? _constants.icons.error : _constants.icons.offline;
        default:
          throw new Error('Wrong state: ' + loadState);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      var icon = void 0;
      if (this.props.stateToIcon) icon = this.props.stateToIcon(this.state);
      if (!icon) icon = this.stateToIcon(this.state);
      return _react2.default.createElement(_Media2.default, _extends({}, this.props, {
        onClick: function onClick() {
          return _this5.onClick();
        },
        icon: icon,
        icons: _defaultIcons2.default
      }));
    }
  }]);

  return ManualLoad;
}(_react.Component);

ManualLoad.propTypes = {
  /** URL of the image */
  src: _propTypes2.default.string.isRequired,
  /** Width of the image in px */
  width: _propTypes2.default.number.isRequired,
  /** Height of the image in px */
  height: _propTypes2.default.number.isRequired,

  placeholder: _propTypes2.default.oneOfType([_propTypes2.default.shape({
    color: _propTypes2.default.string.isRequired
  }), _propTypes2.default.shape({
    lqip: _propTypes2.default.string.isRequired
  })]).isRequired,
  /** Alternative text */
  alt: _propTypes2.default.string,
  /** If you will not pass this value, component will detect onLine status based on browser API, otherwise will use passed value */
  onLine: _propTypes2.default.bool,
  /** If you will pass true it will immediately load image otherwise load will be controlled by user */
  load: _propTypes2.default.bool,
  /** Color of the icon */
  iconColor: _propTypes2.default.string,
  /** Size of the icon in px */
  iconSize: _propTypes2.default.number,
  /** CSS class which will hide elements if JS is disabled */
  noscript: _propTypes2.default.string,
  /** React's style attribute for root element of the component */
  style: _propTypes2.default.object,
  /** React's className attribute for root element of the component */
  className: _propTypes2.default.string,
  /** callback for load state change */
  onLoadStateChange: _propTypes2.default.func,
  /** size of image in bytes */
  size: _propTypes2.default.number,
  /** how much to wait in ms until concider download to slow */
  threshold: _propTypes2.default.number,
  interval: _propTypes2.default.number,
  stateToIcon: _propTypes2.default.func
};
ManualLoad.defaultProps = {
  interval: 500
};
exports.default = ManualLoad;