'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Media = require('../Media');

var _Media2 = _interopRequireDefault(_Media);

var _defaultIcons = require('../defaultIcons');

var _defaultIcons2 = _interopRequireDefault(_defaultIcons);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var load = _constants.icons.load,
    loading = _constants.icons.loading,
    loaded = _constants.icons.loaded,
    error = _constants.icons.error,
    noicon = _constants.icons.noicon,
    offline = _constants.icons.offline;


var MediaWithDefaultIcons = function MediaWithDefaultIcons(props) {
  return _react2.default.createElement(_Media2.default, props);
};

MediaWithDefaultIcons.propTypes = {
  /** URL of the image */
  src: _propTypes2.default.string.isRequired,
  /** Width of the image in px */
  width: _propTypes2.default.number.isRequired,
  /** Height of the image in px */
  height: _propTypes2.default.number.isRequired,
  placeholder: _propTypes2.default.oneOfType([_propTypes2.default.shape({
    /** Solid color placeholder */
    color: _propTypes2.default.string.isRequired
  }), _propTypes2.default.shape({
    /**
     * [Low Quality Image Placeholder](https://github.com/zouhir/lqip)
     * [SVG-Based Image Placeholder](https://github.com/technopagan/sqip)
     * base64 encoded image of low quality
     */
    lqip: _propTypes2.default.string.isRequired
  })]).isRequired,
  /** Alternative text */
  alt: _propTypes2.default.string,
  /** Color of the icon */
  iconColor: _propTypes2.default.string,
  /** Size of the icon in px */
  iconSize: _propTypes2.default.number,
  /** CSS class which will hide elements if JS is disabled */
  noscript: _propTypes2.default.string,
  /** React's style attribute for root element of the component */
  style: _propTypes2.default.object,
  /** React's className attribute for root element of the component */
  className: _propTypes2.default.string,
  /** On click handler */
  onClick: _propTypes2.default.func,
  /** display icon */
  icon: _propTypes2.default.oneOf([load, loading, loaded, error, noicon, offline]),
  /** Map of icons */
  icons: _propTypes2.default.object,
  innerRef: _propTypes2.default.any
};
MediaWithDefaultIcons.defaultProps = _extends({}, _Media2.default.defaultProps, {
  icons: _defaultIcons2.default
});

exports.default = MediaWithDefaultIcons;